#include <iostream>
using namespace std;
int main(){
	int n,q,c,brj=0;
	char b;
	cin>>n>>c>>q;
	int niz[n],p1,p2,r[q];
	for(int i=0;i<n;i++){
	cin>>b;
	if(b==1){
	brj++;niz[i]=1;}
	else niz[i]=0;

	}
	for(int i=0;i<q;i++){
		cin>>p1>>p2;
	
	for(int i=p1;i<=p2;i++){
		if(niz[i]==1){
		niz[i]=0;brj--;}else{
			niz[i]=1; brj++;
		}
	
	}
		r[i]=brj;
	    }
	if(n==c){
	//	r=brj;
	}
	//r=brj;
	for(int i=0;i<q;i++){
	cout<<r[i]<<endl;
	
}
}